Index: tmp/org.txm.setups/nsis/Examples/System/SysFunc.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Examples/System/SysFunc.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/System/SysFunc.nsh	(revision 2956)
@@ -3,16 +3,14 @@
 ; (c) brainsucker, 2002
 ; (r) BSForce
 
-; Check for double includes
+
+!verbose push 3
 !ifndef SysFunc.NSH.Included
 !define SysFunc.NSH.Included
 
-!include "${NSISDIR}\Examples\System\System.nsh"
+!include "System.nsh"
+!include "WinMessages.nsh"
 
-!verbose 3      ; For WinMessages especially
-  !include "WinMessages.nsh"
-!verbose 4
-
 ; ================= GetInstallerExeName implementation =================
 
 ; Adopted Get Parameter function -> now it gets full installer.exe path
@@ -319,17 +317,17 @@
    System::Store "s r8r9"
 
    ; Get module instance
-   System::Call "${sysGetModuleHandle} (i) .r7"
+   System::Call "${sysGetModuleHandle} (p) .r7"
 
    ; Get arrow cursor
-   System::Call "${sysLoadCursor} (0, i ${IDC_ARROW}) .R9" 
+   System::Call "${sysLoadCursor} (0, p ${IDC_ARROW}) .R9" 
 
    ; Get callback
    System::Get "${sysWNDPROC}"
    Pop $3
 
    ; Create window class
-   System::Call "*${stWNDCLASS} (0,r3,0,0,r7,0,R9,0,i 0,'_sp') .R9"
+   System::Call "*${stWNDCLASS} (0,r3,0,0,r7,0,R9,0,p 0,'_sp') .R9"
 
    ; Register window class
    System::Call "${sysRegisterClass} (R9) .R9"
@@ -347,7 +345,7 @@
    !insertmacro SINGLE_CALLBACK 1 $5 1 _systemSplashWndCB
 
    ; Create MSG struct
-   System::Call "*${stMSG} (_) i.R9"
+   System::Call "*${stMSG} (_) p.R9"
 
    ; -------------------------
 repeat:
@@ -371,7 +369,7 @@
 
 finish:
    ; Stop the sound
-   System::Call "${sysPlaySound} (i 0, i 0, i 0)"
+   System::Call "${sysPlaySound} (p 0, p 0, i 0)"
 
    ; Delete bitmap object
    System::Call "${sysDeleteObject} (r6)"
@@ -393,6 +391,5 @@
    System::Store "P0 l"
 FunctionEnd
 
-!verbose 4
-
-!endif
\ No newline at end of file
+!endif
+!verbose pop
\ No newline at end of file
Index: tmp/org.txm.setups/nsis/Examples/NSISMenu.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/NSISMenu.nsi	(revision 0)
+++ tmp/org.txm.setups/nsis/Examples/NSISMenu.nsi	(revision 2956)
@@ -0,0 +1,351 @@
+OutFile "NSIS.exe"
+Name "NSIS Menu"
+Unicode True
+RequestExecutionLevel User
+XPStyle On
+ManifestDPIAware System
+SetCompressor LZMA
+ChangeUI IDD_INST "${NSISDIR}\Contrib\UIs\modern_headerbmp.exe"
+Icon "${NSISDIR}\Contrib\Graphics\Icons\nsis-menu.ico"
+BrandingText " "
+MiscButtonText " " " " " " " "
+InstallButtonText " "
+CompletedText " "
+LangString ^ClickInstall 0 " "
+Caption "$(^Name)"
+
+!macro UNPACKVERFIELD out in shr mask fmt
+!define /redef /math ${out} ${in} >>> ${shr}
+!define /redef /math ${out} ${${out}} & ${mask}
+!define /redef /intfmt ${out} "${fmt}" ${${out}}
+!macroend
+
+!ifndef VER_MAJOR & VER_MINOR
+!ifdef NSIS_PACKEDVERSION
+!insertmacro UNPACKVERFIELD VER_MAJOR ${NSIS_PACKEDVERSION} 24 0x0ff "%X"
+!insertmacro UNPACKVERFIELD VER_MINOR ${NSIS_PACKEDVERSION} 12 0xfff "%X"
+!insertmacro UNPACKVERFIELD VER_REVISION ${NSIS_PACKEDVERSION} 4 255 "%X"
+!insertmacro UNPACKVERFIELD VER_BUILD ${NSIS_PACKEDVERSION} 00 0x00f "%X"
+!endif
+!endif
+!ifdef VER_MAJOR & VER_MINOR
+!define /ifndef VER_REVISION 0
+!define /ifndef VER_BUILD 0
+!searchreplace VERSTR "${NSIS_VERSION}" "v" ""
+VIProductVersion ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}
+VIAddVersionKey "ProductName" "NSIS"
+VIAddVersionKey "ProductVersion" "${VERSTR}"
+VIAddVersionKey "FileVersion" "${VERSTR}"
+VIAddVersionKey "FileDescription" "NSIS Menu"
+VIAddVersionKey "LegalCopyright" "http://nsis.sf.net/License"
+!endif
+
+!include nsDialogs.nsh
+!include WinMessages.nsh
+!include LogicLib.nsh
+!define /IfNDef IDC_CHILDRECT 1018
+!define QUIT_ON_EXECUTE
+!define PR $ExeDir ; Local root path
+!define PD "Docs" ; Local with WWW fallback (located at the same relative path)
+!define WWW "http://nsis.sf.net"
+
+!define CB_HEADER '0x755585 0x222222'
+!define UY_HEADER 28
+!define CT_PAGE '0x000000 0xaaaaaa'
+!define CB_PAGE '0xffffff 0x111111'
+!define CT_SECTION '0x666666 0xeeeeee'
+!define CB_SECTION '${CB_PAGE}'
+!define UY_SECTION 11 ; Height of a section
+!define UY_SECTIONBPAD 2 ; Extra padding on the bottom of section headers
+!define UY_TXT 9 ; Height of a normal item
+!define UY_TXTBPAD 1 ; Extra padding on the bottom of normal items
+!define UX_COLPAD 7 ; Spacing between columns
+!define UY_ROW2 104 ; Absolute position of the 2nd row
+!define CT_LINK '0x0c6e97 0x0c6e97' ; SYSCLR:HOTLIGHT
+!define /Math UX_PAGE 00 + ${UX_COLPAD}
+!define /Math UY_PAGE ${UY_HEADER} + 20
+!define UX ${UX_PAGE}
+!define CB_FOOTERLINE '0xc4c4c4 0x333333'
+!define CT_FOOTER '0xbbbbbb 0x444444'
+
+Var UseLightTheme
+
+Function .onGUIInit
+ReadRegDWORD $UseLightTheme HKCU "Software\NSIS" "UseLightTheme"
+StrCmp $UseLightTheme "" 0 +2
+ReadRegDWORD $UseLightTheme HKCU "Software\Microsoft\Windows\CurrentVersion\Themes\Personalize" "AppsUseLightTheme"
+StrCmp $UseLightTheme "" 0 +2
+StrCpy $UseLightTheme 1 ; Default
+
+StrCmp $UseLightTheme "0" 0 +2
+System::Call 'USER32::SetProp(p$hWndParent,t"UseImmersiveDarkModeColors",i1)'
+FunctionEnd
+
+!define SetCtlColors "!insertmacro SetCtlColors "
+!macro SetCtlColors hWnd ctlig ctdar cblig cbdar
+StrCmp $UseLightTheme "0" 0 +3
+SetCtlColors ${hWnd} "${ctdar}" ${cbdar}
+Goto +2
+SetCtlColors ${hWnd} "${ctlig}" ${cblig}
+!macroend
+
+
+Function PageLeave
+System::Call 'USER32::GetFocus()p.r0'
+System::Call 'USER32::GetDlgCtrlID(pr0)i.r1'
+System::Call 'USER32::GetParent(pr0)p.r2'
+SendMessage $2 ${WM_COMMAND} $1 $0 ; Handle <ENTER> in dialog by pretending it was a click on the active control
+Abort
+FunctionEnd
+
+Function PageCreate
+GetDlgItem $0 $hWndParent 1
+ShowWindow $0 0
+GetDlgItem $0 $hWndParent 2
+ShowWindow $0 0
+
+System::Call 'USER32::GetClientRect(p$hWndParent,@r0)'
+System::Call '*$0(i,i,i.r3,i.r4)'
+GetDlgItem $0 $hWndParent ${IDC_CHILDRECT}
+System::Call 'USER32::MoveWindow(pr0,i0,i0,ir3,ir4,i0)'
+
+nsDialogs::Create ${IDC_CHILDRECT}
+Pop $R9
+${SetCtlColors} $R9 ${CT_PAGE} ${CB_PAGE}
+
+!macro StartColumn W
+!define /ReDef UY ${UY_PAGE}
+!define /ReDef UX_W ${W}
+!ifdef UX_INTERNAL_PREV_W
+!define /ReDef /Math UX ${UX} + ${UX_INTERNAL_PREV_W}
+!define /ReDef /Math UX ${UX} + ${UX_COLPAD}
+!define /ReDef UX_INTERNAL_PREV_W ${UX_W}
+!else
+!define /Math UX_INTERNAL_PREV_W 0 + ${UX_W}
+!endif
+!macroend
+!macro CreateHeader Txt W
+!define /ReDef /Math W ${W} + 4 ; Make it slightly wider
+${NSD_CreateLabel} ${UX}u ${UY}u ${W}u ${UY_SECTION}u "${Txt}"
+Pop $0
+${SetCtlColors} $0 ${CT_SECTION} transparent transparent
+SendMessage $0 ${WM_SETFONT} ${HF_HEADER} 1
+!define /ReDef /Math UY ${UY} + ${UY_SECTION}
+!define /ReDef /Math UY ${UY} + ${UY_SECTIONBPAD}
+!macroend
+!macro CreateControl Class Txt W H
+${NSD_Create${Class}} ${UX}u ${UY}u ${W}u ${H}u "${Txt}"
+!define /ReDef /Math UY ${UY} + ${H}
+!define /ReDef /Math UY ${UY} + ${UY_TXTBPAD}
+!macroend
+!macro CreateSimpleLinkHelper Txt Url W
+!insertmacro CreateControl Link "${Txt}|${Url}" ${W} ${UY_TXT}
+!macroend
+!macro CreateSimpleLink Txt Url W
+!insertmacro CreateSimpleLinkHelper "${Txt}" "${Url}" ${W}
+Call ConfigureLink
+!macroend
+
+
+; --- Header ---
+!define HF_HEADER $R8
+CreateFont ${HF_HEADER} "Arial" ${UY_SECTION} 700
+
+nsDialogs::CreateControl ${__NSD_Label_CLASS} ${__NSD_Label_STYLE} ${__NSD_Label_EXSTYLE} 33u 0 -33u ${UY_HEADER}u ""
+Pop $0
+${SetCtlColors} $0 0xffffff 0xffffff ${CB_HEADER}
+
+nsDialogs::CreateControl ${__NSD_Icon_CLASS} ${__NSD_Icon_STYLE}|${SS_CENTERIMAGE}|${SS_CENTER} ${__NSD_Icon_EXSTYLE} 0 0 33u ${UY_HEADER}u ""
+Pop $0
+${SetCtlColors} $0 "" "" ${CB_HEADER}
+${NSD_SetIconFromInstaller} $0 $1
+
+CreateFont $1 "Trebuchet MS" 17
+!searchreplace VERSTR "${NSIS_VERSION}" "v" ""
+nsDialogs::CreateControl ${__NSD_Label_CLASS} ${__NSD_Label_STYLE}|${SS_CENTERIMAGE}|${SS_ENDELLIPSIS} ${__NSD_Label_EXSTYLE} 34u 1u -34u ${UY_HEADER}u "nullsoft scriptable install system ${VERSTR}"
+Pop $0
+SetCtlColors $0 0x3A2A42 transparent
+SendMessage $0 ${WM_SETFONT} $1 1
+nsDialogs::CreateControl ${__NSD_Label_CLASS} ${__NSD_Label_STYLE}|${SS_CENTERIMAGE}|${SS_ENDELLIPSIS} ${__NSD_Label_EXSTYLE} 33u 0 -33u ${UY_HEADER}u "nullsoft scriptable install system ${VERSTR}"
+Pop $0
+SetCtlColors $0 0xffffff transparent
+SendMessage $0 ${WM_SETFONT} $1 1
+
+
+; --- Page ---
+!insertmacro StartColumn 90
+!insertmacro CreateHeader "Compiler" ${UX_W}
+!insertmacro CreateSimpleLink "Compile NSI scripts" "${PR}\MakeNSISW" ${UX_W}
+!insertmacro CreateSimpleLink "Installer based on .ZIP file" "${PR}\bin\Zip2Exe" ${UX_W}
+
+
+!define /ReDef UY ${UY_ROW2}
+!insertmacro CreateHeader "Developer Center" ${UX_W}
+!define /ReDef UY_MULTILINE 42
+!insertmacro CreateControl Label "Many more examples, tutorials, plug-ins and NSIS-releted software are available at the online Developer Center." ${UX_W} ${UY_MULTILINE}
+Pop $0
+${SetCtlColors} $0 ${CT_PAGE} ${CB_PAGE}
+
+
+!insertmacro StartColumn 80
+!insertmacro CreateHeader "Documentation" ${UX_W}
+!insertmacro CreateSimpleLink "NSIS Users Manual" "${PR}\NSIS.chm|${WWW}/Docs/" ${UX_W}
+!insertmacro CreateSimpleLink "Example scripts" "${PR}\Examples|${WWW}/Examples" ${UX_W}
+!insertmacro CreateSimpleLink "Modern UI 2" "${PD}\Modern UI 2\Readme.html" ${UX_W}
+
+
+!define /ReDef UY ${UY_ROW2}
+!insertmacro CreateHeader "Online Help" ${UX_W}
+!insertmacro CreateSimpleLink "Developer Center" "${WWW}/Developer_Center" ${UX_W}
+!insertmacro CreateSimpleLink "FAQ" "${WWW}/FAQ" ${UX_W}
+!insertmacro CreateSimpleLink "Forum" "http://forums.winamp.com/forumdisplay.php?forumid=65" ${UX_W}
+;"Project Tracker" "http://sourceforge.net/tracker/?group_id=22049"
+!insertmacro CreateSimpleLink "Bug Tracker" "http://sourceforge.net/tracker/?group_id=22049&atid=373085" ${UX_W}
+!insertmacro CreateSimpleLink "Stackoverflow" "http://stackoverflow.com/questions/tagged/nsis" ${UX_W}
+!insertmacro CreateSimpleLink "Slack collaboration hub" "${WWW}/r/Slack" ${UX_W}
+;insertmacro CreateSimpleLink "IRC channel" "irc://irc.landoleet.org/nsis" ${UX_W}
+;"Pastebin" "http://nsis.pastebin.com/index/1FtyKP89"
+;"Search" "http://www.google.com/cse/home?cx=005317984255499820329:c_glv1-6a6a"
+
+
+!insertmacro StartColumn 130
+!insertmacro CreateHeader "Plug-ins" ${UX_W}
+!macro CreatePluginLink Name Desc Url
+!define /ReDef SAVE_UY ${UY}
+!insertmacro CreateSimpleLinkHelper "${Name}" "${Url}" ${UX_W} ; AdjustLinkPair will configure this link
+!define /ReDef UY ${SAVE_UY}
+!insertmacro CreateControl Label "${Name} - ${Desc}" ${UX_W} ${UY_TXT}
+Call AdjustLinkPair
+!macroend
+!insertmacro CreatePluginLink "AdvSplash" "splash with fade in/out"     "${PD}\AdvSplash\advsplash.txt"
+!insertmacro CreatePluginLink "Banner"    "banner with custom text"     "${PD}\Banner\Readme.txt"
+!insertmacro CreatePluginLink "BgImage"   "background image"            "${PD}\BgImage\BgImage.txt"
+!insertmacro CreatePluginLink "Dialer"    "internet connection"         "${PD}\Dialer\Dialer.txt"
+!insertmacro CreatePluginLink "Math"      "math operations"             "${PD}\Math\Math.txt"
+!insertmacro CreatePluginLink "nsDialogs" "custom wizard pages"         "${PD}\nsDialogs\Readme.html"
+!insertmacro CreatePluginLink "nsExec"    "launch command line tools"   "${PD}\nsExec\nsExec.txt"
+!insertmacro CreatePluginLink "NSISdl"    "download files"              "${PD}\NSISdl\Readme.txt"
+!insertmacro CreatePluginLink "Splash"    "splash screen"               "${PD}\Splash\splash.txt"
+!insertmacro CreatePluginLink "StartMenu" "Start Menu folder selection" "${PD}\StartMenu\Readme.txt"
+!insertmacro CreatePluginLink "System"    "Windows API calls"           "${PD}\System\System.html"
+!insertmacro CreatePluginLink "VPatch"    "update existing files"       "${PD}\VPatch\Readme.html"
+
+
+; --- Footer ---
+${NSD_CreateLabel} 0 -22u 100% 1 ""
+Pop $0
+${SetCtlColors} $0 000000 000000 ${CB_FOOTERLINE}
+
+nsDialogs::CreateControl ${__NSD_Label_CLASS} ${__NSD_Label_STYLE}|${SS_CENTERIMAGE}|${SS_NOTIFY} ${__NSD_Label_EXSTYLE} -110u -20u 100% 20u "nsis.sourceforge.net"
+Pop $0
+${SetCtlColors} $0 ${CT_FOOTER} transparent transparent
+SendMessage $0 ${WM_SETFONT} ${HF_HEADER} 1
+nsDialogs::SetUserData $0 "https://nsis.sourceforge.io"
+${NSD_OnClick} $0 OnLinkClick
+
+nsDialogs::Show
+FunctionEnd
+
+Function OnLinkClick
+Pop $1 ; HWND
+nsDialogs::GetUserData $1
+Call SplitPipe
+Pop $0 ; First URL in UserData from SplitPipe
+StrCpy $3 ""
+StrCpy $1 $0 4 ; Copy length of ${PD}
+${IfThen} $1 == "${PD}" ${|} StrCpy $3 "${PR}\" ${|}
+!ifdef QUIT_ON_EXECUTE
+System::Call 'USER32::GetKeyState(i0x11)i.r9' ; VK_CONTROL
+!endif
+ClearErrors
+ExecShell "" "$3$0"
+Pop $1 ; ... the rest of SplitPipe ...
+${If} $1 != ""  ; ... might contain a fallback location
+	StrCpy $0 $1
+	StrCpy $3 ""
+${ElseIf} $3 != "" ; Local docs path failed, use WWW fallback
+	StrCpy $3 0
+	slashconvloop:
+		StrCpy $2 $0 1 $3
+		${If} $2 == "\"
+			StrCpy $2 $0 $3
+			IntOp $3 $3 + 1
+			StrCpy $0 $0 "" $3
+			StrCpy $0 "$2/$0"
+		${Else}
+			IntOp $3 $3 + 1
+		${EndIf}
+		StrCmp $2 "" 0 slashconvloop
+	StrCpy $3 "${WWW}/"
+${EndIf}
+${If} "$3$1" != ""
+${AndIf} ${Errors}
+	ExecShell "" "$3$0"
+${EndIf}
+${If} ${Errors}
+	!ifdef QUIT_ON_EXECUTE
+	StrCpy $9 0 ; Don't allow close
+	!endif
+	MessageBox MB_IconStop 'Error: Unable to open "$0"!'
+${EndIf}
+!ifdef QUIT_ON_EXECUTE
+${IfThen} $9 < 0 ${|} SendMessage $hWndParent ${WM_CLOSE} 0 0 ${|}
+!endif
+FunctionEnd
+
+Function ConfigureLink
+Pop $1 ; HWND
+${NSD_OnClick} $1 OnLinkClick
+${SetCtlColors} $1 ${CT_LINK} ${CB_PAGE}
+${NSD_GetText} $1 $4
+Push $4
+Call SplitPipe
+Pop $4
+Pop $2
+${NSD_SetText} $1 $4
+nsDialogs::SetUserData $1 $2
+System::Call 'USER32::GetDC(pr1)p.r3'
+SendMessage $1 ${WM_GETFONT} 0 0 $5
+System::Call 'GDI32::SelectObject(pr3,pr5)p.s'
+StrLen $5 $4
+System::Call 'GDI32::GetTextExtentPoint32(pr3,tr4,ir5,@r5)'
+System::Call '*$5(i.r6)'
+System::Call 'GDI32::SelectObject(pr3,ps)'
+System::Call 'USER32::ReleaseDC(pr1,pr3)'
+System::Call 'USER32::GetWindowRect(pr1,@r3)'
+System::Call '*$3(i,i.r5,i,i.r7)'
+IntOp $7 $7 - $5
+IntOp $6 $6 + 4 ; Padding for focus rect
+System::Call 'USER32::SetWindowPos(pr1,p,i,i,ir6,ir7,i0x16)'
+FunctionEnd
+
+Function AdjustLinkPair
+Pop $2 ; Label
+${SetCtlColors} $2 ${CT_PAGE} ${CB_PAGE}
+Call ConfigureLink
+FunctionEnd
+
+Function SplitPipe
+Exch $0
+Push $1
+Push $2
+StrCpy $2 0
+findSep:
+StrCpy $1 $0 1 $2
+IntOp $2 $2 + 1
+StrCmp $1 "" +2
+StrCmp $1 "|" "" findSep
+StrCpy $1 $0 "" $2
+IntOp $2 $2 - 1
+StrCpy $0 $0 $2
+Pop $2
+Exch $1
+Exch
+Exch $0
+FunctionEnd
+
+Section
+SectionEnd
+
+Page Custom PageCreate PageLeave
+!pragma warning disable 8000 ; Page instfiles not used
\ No newline at end of file
Index: tmp/org.txm.setups/nsis/Examples/BgImage/Example.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/BgImage/Example.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/BgImage/Example.nsi	(revision 2956)
@@ -3,6 +3,7 @@
 OutFile "BgImage Test.exe"
 
 XPStyle on
+RequestExecutionLevel user
 
 !define DEBUG
 !macro GetReturnValue
Index: tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.sln
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.sln	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.sln	(revision 2956)
@@ -1,7 +1,7 @@
 ï»¿
 Microsoft Visual Studio Solution File, Format Version 10.00
 # Visual Studio 2008
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "exdll", "exdll.vcproj", "{5E3E2AFD-1D6B-4997-A9B5-8ECBC8F6C31A}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "exdll", "exdll-vs2008.vcproj", "{5E3E2AFD-1D6B-4997-A9B5-8ECBC8F6C31A}"
 EndProject
 Global
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
Index: tmp/org.txm.setups/nsis/Examples/Plugin/exdll_with_unit.dpr
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/exdll_with_unit.dpr	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/exdll_with_unit.dpr	(revision 2956)
@@ -9,12 +9,36 @@
   Tested in Delphi 7.0
 }
 
+// Example NSIS code
+{
+Section
+  exdll_with_unit::registerplugincallback
+
+  StrCpy $0 "Hello"
+  Push "World"
+  exdll_with_unit::pop_dlg_push
+  Pop $1
+  DetailPrint $$0=$0
+  DetailPrint $$1=$1
+
+  GetFunctionAddress $0 nsistest
+  Push $0
+  exdll_with_unit::callnsisfunc
+SectionEnd
+
+Function nsistest
+  DetailPrint "Hello from NSIS function"
+FunctionEnd
+}
+
+
 library exdll;
 
 uses
   nsis, windows;
 
-procedure ex_dll(const hwndParent: HWND; const string_size: integer; const variables: PChar; const stacktop: pointer); cdecl;
+
+procedure pop_dlg_push(const hwndParent: HWND; const string_size: integer; const variables: PChar; const stacktop: pointer); cdecl;
 begin
   // set up global variables
   Init(hwndParent, string_size, variables, stacktop);
@@ -25,7 +49,45 @@
   SetUserVariable(INST_0, 'This is user var $0');
 end;
 
-exports ex_dll;
 
+procedure callnsisfunc(const hwndParent: HWND; const string_size: integer; const variables: PChar; const stacktop: pointer; const extraparameters: pointer); cdecl;
+var
+  FuncAddr : String;
 begin
+  Init(hwndParent, string_size, variables, stacktop, extraparameters);
+
+  FuncAddr := PopString();
+  Call(FuncAddr);
+end;
+
+
+function mynsiscallback(const NSPIM: TNSPIM): Pointer; cdecl;
+begin
+  Result := nil;
+  if NSPIM = NSPIM_UNLOAD then
+    begin
+      NSISDialog(PChar('NSPIM_UNLOAD is the final callback, goodbye...'), PChar('mynsiscallback'), MB_OK);
+    end;
+end;
+
+
+procedure registerplugincallback(const hwndParent: HWND; const string_size: integer; const variables: PChar; const stacktop: pointer; const extraparameters: pointer); cdecl;
+var
+  ThisDllInstance : HMODULE;
+begin
+  Init(hwndParent, string_size, variables, stacktop, extraparameters);
+
+  if g_extraparameters <> nil then
+  begin
+    ThisDllInstance := hInstance;
+    TRegisterPluginCallback(g_extraparameters.RegisterPluginCallback)(ThisDllInstance, @mynsiscallback);
+  end;
+end;
+
+
+exports pop_dlg_push;
+exports callnsisfunc;
+exports registerplugincallback;
+
+begin
 end.
Index: tmp/org.txm.setups/nsis/Examples/Plugin/exdll.c
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/exdll.c	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/exdll.c	(revision 2956)
@@ -2,37 +2,41 @@
 #include <nsis/pluginapi.h> // nsis plugin
 
 HINSTANCE g_hInstance;
-
 HWND g_hwndParent;
 
+// To work with Unicode version of NSIS, please use TCHAR-type
+// functions for accessing the variables and the stack.
+
 void __declspec(dllexport) myFunction(HWND hwndParent, int string_size, 
-                                      char *variables, stack_t **stacktop,
-                                      extra_parameters *extra)
+                                      LPTSTR variables, stack_t **stacktop,
+                                      extra_parameters *extra, ...)
 {
-  g_hwndParent=hwndParent;
-
   EXDLL_INIT();
+  g_hwndParent = hwndParent;
 
 
   // note if you want parameters from the stack, pop them off in order.
-  // i.e. if you are called via exdll::myFunction file.dat poop.dat
+  // i.e. if you are called via exdll::myFunction file.dat read.txt
   // calling popstring() the first time would give you file.dat,
-  // and the second time would give you poop.dat. 
+  // and the second time would give you read.txt. 
   // you should empty the stack of your parameters, and ONLY your
   // parameters.
 
   // do your stuff here
   {
-    char buf[1024];
-    wsprintf(buf,"$0=%s\n",getuservariable(INST_0));
-    MessageBox(g_hwndParent,buf,0,MB_OK);
+    LPTSTR msgbuf = (LPTSTR) GlobalAlloc(GPTR, (3 + string_size + 1) * sizeof(*msgbuf));
+    if (msgbuf)
+    {
+      wsprintf(msgbuf, TEXT("$0=%s"), getuservariable(INST_0));
+      MessageBox(g_hwndParent, msgbuf, TEXT("Message from example plugin"), MB_OK);
+      GlobalFree(msgbuf);
+    }
   }
 }
 
 
-
 BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
 {
-  g_hInstance=hInst;
-	return TRUE;
+  g_hInstance = hInst;
+  return TRUE;
 }
Index: tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.vcproj
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.vcproj	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/exdll-vs2008.vcproj	(revision 2956)
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="Windows-1252"?>
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="9,00"
+	Version="9.00"
 	Name="exdll"
 	ProjectGUID="{5E3E2AFD-1D6B-4997-A9B5-8ECBC8F6C31A}"
 	RootNamespace="exdll"
@@ -80,6 +80,7 @@
 				OutputFile=".\Release/exdll.dll"
 				LinkIncremental="1"
 				SuppressStartupBanner="true"
+				GenerateManifest="false"
 				IgnoreAllDefaultLibraries="true"
 				IgnoreDefaultLibraryNames="libc.lib"
 				ProgramDatabaseFile=".\Release/exdll.pdb"
@@ -179,6 +180,7 @@
 				OutputFile=".\Debug/exdll.dll"
 				LinkIncremental="2"
 				SuppressStartupBanner="true"
+				GenerateManifest="false"
 				IgnoreAllDefaultLibraries="true"
 				IgnoreDefaultLibraryNames=""
 				GenerateDebugInformation="true"
Index: tmp/org.txm.setups/nsis/Examples/Plugin/nsis/api.h
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/nsis/api.h	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/nsis/api.h	(revision 2956)
@@ -3,7 +3,7 @@
  * 
  * This file is a part of NSIS.
  * 
- * Copyright (C) 1999-2015 Nullsoft and Contributors
+ * Copyright (C) 1999-2020 Nullsoft and Contributors
  * 
  * Licensed under the zlib/libpng license (the "License");
  * you may not use this file except in compliance with the License.
@@ -27,8 +27,8 @@
 // NSIS Plug-In Callback Messages
 enum NSPIM 
 {
-	NSPIM_UNLOAD,    // This is the last message a plugin gets, do final cleanup
-	NSPIM_GUIUNLOAD, // Called after .onGUIEnd
+  NSPIM_UNLOAD,    // This is the last message a plugin gets, do final cleanup
+  NSPIM_GUIUNLOAD, // Called after .onGUIEnd
 };
 
 // Prototype for callbacks registered with extra_parameters->RegisterPluginCallback()
@@ -36,35 +36,37 @@
 // Should always be __cdecl for future expansion possibilities
 typedef UINT_PTR (*NSISPLUGINCALLBACK)(enum NSPIM);
 
-// extra_parameters data structures containing other interesting stuff
-// but the stack, variables and HWND passed on to plug-ins.
+// extra_parameters data structure containing other interesting stuff
+// besides the stack, variables and HWND passed on to plug-ins.
 typedef struct
 {
-  int autoclose;
-  int all_user_var;
-  int exec_error;
-  int abort;
-  int exec_reboot; // NSIS_SUPPORT_REBOOT
-  int reboot_called; // NSIS_SUPPORT_REBOOT
-  int XXX_cur_insttype; // depreacted
-  int plugin_api_version; // see NSISPIAPIVER_CURR
-                          // used to be XXX_insttype_changed
-  int silent; // NSIS_CONFIG_SILENT_SUPPORT
-  int instdir_error;
-  int rtl;
-  int errlvl;
-  int alter_reg_view;
-  int status_update;
+  int autoclose;          // SetAutoClose
+  int all_user_var;       // SetShellVarContext: User context = 0, Machine context = 1
+  int exec_error;         // IfErrors/ClearErrors/SetErrors
+  int abort;              // IfAbort
+  int exec_reboot;        // IfRebootFlag/SetRebootFlag (NSIS_SUPPORT_REBOOT)
+  int reboot_called;      // NSIS_SUPPORT_REBOOT
+  int XXX_cur_insttype;   // Deprecated
+  int plugin_api_version; // Plug-in ABI. See NSISPIAPIVER_CURR (Note: used to be XXX_insttype_changed)
+  int silent;             // IfSilent/SetSilent (NSIS_CONFIG_SILENT_SUPPORT)
+  int instdir_error;      // GetInstDirError
+  int rtl;                // IfRtlLanguage: 1 if $LANGUAGE is a RTL language
+  int errlvl;             // SetErrorLevel
+  int alter_reg_view;     // SetRegView: Default View = 0, Alternative View = (sizeof(void*) > 4 ? KEY_WOW64_32KEY : KEY_WOW64_64KEY)
+  int status_update;      // SetDetailsPrint
 } exec_flags_t;
 
 #ifndef NSISCALL
 #  define NSISCALL __stdcall
 #endif
+#if !defined(_WIN32) && !defined(LPTSTR)
+#  define LPTSTR TCHAR*
+#endif
 
 typedef struct {
   exec_flags_t *exec_flags;
   int (NSISCALL *ExecuteCodeSegment)(int, HWND);
-  void (NSISCALL *validate_filename)(char *);
+  void (NSISCALL *validate_filename)(LPTSTR);
   int (NSISCALL *RegisterPluginCallback)(HMODULE, NSISPLUGINCALLBACK); // returns 0 on success, 1 if already registered and < 0 on errors
 } extra_parameters;
 
@@ -80,4 +82,4 @@
 // sent as wParam with WM_NOTIFY_OUTER_NEXT when user cancels - heed its warning
 #define NOTIFY_BYE_BYE 'x'
 
-#endif /* _PLUGIN_H_ */
+#endif /* _NSIS_EXEHEAD_API_H_ */
Index: tmp/org.txm.setups/nsis/Examples/Plugin/nsis/nsis_tchar.h
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/nsis/nsis_tchar.h	(revision 0)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/nsis/nsis_tchar.h	(revision 2956)
@@ -0,0 +1,229 @@
+/*
+ * nsis_tchar.h
+ * 
+ * This file is a part of NSIS.
+ * 
+ * Copyright (C) 1999-2020 Nullsoft and Contributors
+ * 
+ * This software is provided 'as-is', without any express or implied
+ * warranty.
+ *
+ * For Unicode support by Jim Park -- 08/30/2007
+ */
+
+// Jim Park: Only those we use are listed here.
+
+#pragma once
+
+#ifdef _UNICODE
+
+#ifndef _T
+#define __T(x)   L ## x
+#define _T(x)    __T(x)
+#define _TEXT(x) __T(x)
+#endif
+
+#ifndef _TCHAR_DEFINED
+#define _TCHAR_DEFINED
+#if !defined(_NATIVE_WCHAR_T_DEFINED) && !defined(_WCHAR_T_DEFINED)
+typedef unsigned short TCHAR;
+#else
+typedef wchar_t TCHAR;
+#endif
+#endif
+
+
+// program
+#define _tenviron   _wenviron
+#define __targv     __wargv
+
+// printfs
+#define _ftprintf   fwprintf
+#define _sntprintf  _snwprintf
+#if (defined(_MSC_VER) && (_MSC_VER<=1310||_MSC_FULL_VER<=140040310)) || defined(__MINGW32__)
+#	define _stprintf   swprintf
+#else
+#	define _stprintf   _swprintf
+#endif
+#define _tprintf    wprintf
+#define _vftprintf  vfwprintf
+#define _vsntprintf _vsnwprintf
+#if defined(_MSC_VER) && (_MSC_VER<=1310)
+#	define _vstprintf  vswprintf
+#else
+#	define _vstprintf  _vswprintf
+#endif
+
+// scanfs
+#define _tscanf     wscanf
+#define _stscanf    swscanf
+
+// string manipulations
+#define _tcscat     wcscat
+#define _tcschr     wcschr
+#define _tcsclen    wcslen
+#define _tcscpy     wcscpy
+#define _tcsdup     _wcsdup
+#define _tcslen     wcslen
+#define _tcsnccpy   wcsncpy
+#define _tcsncpy    wcsncpy
+#define _tcsrchr    wcsrchr
+#define _tcsstr     wcsstr
+#define _tcstok     wcstok
+
+// string comparisons
+#define _tcscmp     wcscmp
+#define _tcsicmp    _wcsicmp
+#define _tcsncicmp  _wcsnicmp
+#define _tcsncmp    wcsncmp
+#define _tcsnicmp   _wcsnicmp
+
+// upper / lower
+#define _tcslwr     _wcslwr
+#define _tcsupr     _wcsupr
+#define _totlower   towlower
+#define _totupper   towupper
+
+// conversions to numbers
+#define _tcstoi64   _wcstoi64
+#define _tcstol     wcstol
+#define _tcstoul    wcstoul
+#define _tstof      _wtof
+#define _tstoi      _wtoi
+#define _tstoi64    _wtoi64
+#define _ttoi       _wtoi
+#define _ttoi64     _wtoi64
+#define _ttol       _wtol
+
+// conversion from numbers to strings
+#define _itot       _itow
+#define _ltot       _ltow
+#define _i64tot     _i64tow
+#define _ui64tot    _ui64tow
+
+// file manipulations
+#define _tfopen     _wfopen
+#define _topen      _wopen
+#define _tremove    _wremove
+#define _tunlink    _wunlink
+
+// reading and writing to i/o
+#define _fgettc     fgetwc
+#define _fgetts     fgetws
+#define _fputts     fputws
+#define _gettchar   getwchar
+
+// directory
+#define _tchdir     _wchdir
+
+// environment
+#define _tgetenv    _wgetenv
+#define _tsystem    _wsystem
+
+// time
+#define _tcsftime   wcsftime
+
+#else // ANSI
+
+#ifndef _T
+#define _T(x)    x
+#define _TEXT(x) x
+#endif
+
+#ifndef _TCHAR_DEFINED
+#define _TCHAR_DEFINED
+typedef char TCHAR;
+#endif
+
+// program
+#define _tenviron   environ
+#define __targv     __argv
+
+// printfs
+#define _ftprintf   fprintf
+#define _sntprintf  _snprintf
+#define _stprintf   sprintf
+#define _tprintf    printf
+#define _vftprintf  vfprintf
+#define _vsntprintf _vsnprintf
+#define _vstprintf  vsprintf
+
+// scanfs
+#define _tscanf     scanf
+#define _stscanf    sscanf
+
+// string manipulations
+#define _tcscat     strcat
+#define _tcschr     strchr
+#define _tcsclen    strlen
+#define _tcscnlen   strnlen
+#define _tcscpy     strcpy
+#define _tcsdup     _strdup
+#define _tcslen     strlen
+#define _tcsnccpy   strncpy
+#define _tcsrchr    strrchr
+#define _tcsstr     strstr
+#define _tcstok     strtok
+
+// string comparisons
+#define _tcscmp     strcmp
+#define _tcsicmp    _stricmp
+#define _tcsncmp    strncmp
+#define _tcsncicmp  _strnicmp
+#define _tcsnicmp   _strnicmp
+
+// upper / lower
+#define _tcslwr     _strlwr
+#define _tcsupr     _strupr
+
+#define _totupper   toupper
+#define _totlower   tolower
+
+// conversions to numbers
+#define _tcstol     strtol
+#define _tcstoul    strtoul
+#define _tstof      atof
+#define _tstoi      atoi
+#define _tstoi64    _atoi64
+#define _tstoi64    _atoi64
+#define _ttoi       atoi
+#define _ttoi64     _atoi64
+#define _ttol       atol
+
+// conversion from numbers to strings
+#define _i64tot     _i64toa
+#define _itot       _itoa
+#define _ltot       _ltoa
+#define _ui64tot    _ui64toa
+
+// file manipulations
+#define _tfopen     fopen
+#define _topen      _open
+#define _tremove    remove
+#define _tunlink    _unlink
+
+// reading and writing to i/o
+#define _fgettc     fgetc
+#define _fgetts     fgets
+#define _fputts     fputs
+#define _gettchar   getchar
+
+// directory
+#define _tchdir     _chdir
+
+// environment
+#define _tgetenv    getenv
+#define _tsystem    system
+
+// time
+#define _tcsftime   strftime
+
+#endif
+
+// is functions (the same in Unicode / ANSI)
+#define _istgraph   isgraph
+#define _istascii   __isascii
+
+#define __TFILE__ _T(__FILE__)
+#define __TDATE__ _T(__DATE__)
+#define __TTIME__ _T(__TIME__)
